#include "opensbi/extensions/ipi.h"

namespace drivers {
namespace opensbi::ipi {

    namespace {
        enum class ExtensionId {
            IPI = 0x735049
        };

        enum class FunctionId {
            SEND_IPI
        };
    }

    SbiRet send_ipi(
            unsigned long hart_mask,
            unsigned long hart_mask_base) {
        return ecall(
            static_cast<sbiword_t>(ExtensionId::IPI),
            static_cast<sbiword_t>(FunctionId::SEND_IPI),
            hart_mask,
            hart_mask_base);
    }

}  // End namespace opensbi::ipi
}  // End namespace drivers

